<?php
if (!defined('ABSPATH')) {
  exit; // Exit if accessed directly.
}

/**
 * Image Carousel Widget
 */

class Testimonial2_Widget extends \Elementor\Widget_Base {

  public function get_name() {
    return 'morat-Testimonial2';
  }

  
  
  
  public function get_title() {
    return esc_html__('Testimonial2 Carousel', 'Testimonial2-widget');
  }

  public function get_categories() {
    return ['basic'];
  }


  public function get_style_depends() {
    return ['main-style', 'slick'];
  }


  /**
   * Controls
   */

  protected function register_controls() {
	  
	  

	
    // Content Section
    $this->start_controls_section(
      'content_section',
      [
        'label' => 'Content',
        'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
      ]
    );

    $repeater = new \Elementor\Repeater();

		// Service Style
    $this->add_control(
      'testimonial_style',
      [
        'label' => esc_html__('slider Style', 'textdomain'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => '1',
        'options' => [
          '1'  => esc_html__('One', 'textdomain'),
          '2'  => esc_html__('Two', 'textdomain'),
        ],
      ]
    );
	$this->add_responsive_control(
			'align',
			[
				'label' => esc_html__( 'Alignment', 'elementor' ),
				'type' => \Elementor\Controls_Manager::CHOOSE,
				'options' => [
					'left' => [
						'title' => esc_html__( 'Left', 'elementor' ),
						'icon' => 'eicon-text-align-left',
					],
					'center' => [
						'title' => esc_html__( 'Center', 'elementor' ),
						'icon' => 'eicon-text-align-center',
					],
					'right' => [
						'title' => esc_html__( 'Right', 'elementor' ),
						'icon' => 'eicon-text-align-right',
					],
					'justify' => [
						'title' => esc_html__( 'Justified', 'elementor' ),
						'icon' => 'eicon-text-align-justify',
					],
				],
				'selectors' => [
					'{{WRAPPER}} .testi_text' => 'text-align: {{VALUE}};',
				],
			]
		);
	

	// Top Title  
    $repeater->add_control(
      'top_title',
      [
        'label' => esc_html__('Top Title', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::TEXTAREA,
        'default' => esc_html__('Top Title Here', 'plugin-name'),
      ]
    );

	
    // Main Title
    $repeater->add_control(
      'list_main_title',
      [
        'label' => esc_html__('Main Title', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::TEXTAREA,
        'default' => esc_html__('Main Title Here', 'plugin-name'),
        'label_block' => true,
      ]
    );

	// content Title
    $repeater->add_control(
      'list_content_title',
      [
        'label' => esc_html__('Content Title ', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::TEXTAREA,
        'default' => esc_html__('Content Title Here', 'plugin-name'),
        'label_block' => true,
      ]
    );
	// Slider Image
    $repeater->add_control(
      'left_image',
      [
        'label' => esc_html__('Left Image', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::MEDIA,
        'default' => [
          'url' => \Elementor\Utils::get_placeholder_image_src(),
        ],
      ]
    );
	
	

	
    $this->add_control(
      'list',
      [
        'label' => esc_html__('Slider List', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::REPEATER,
        'fields' => $repeater->get_controls(),
        
        'default' => [
          [
            'top_title' => esc_html__('Top title', 'plugin-name'),
            'list_main_title' => esc_html__('Main title #1', 'plugin-name'),
            'list_sub_title' => esc_html__('Item content. Click the edit button to change this text.', 'plugin-name'),

            
          ],
          [
            'list_main_title' => esc_html__('Main title #2', 'plugin-name'),
            'list_sub_title' => esc_html__('Item content. Click the edit button to change this text.', 'plugin-name'),
			'list_subs_title' => esc_html__('List Sub Title', 'plugin-name'),
          ],
        ],
        'title_field' => '{{{ list_main_title }}}',
      ]
    );

	

	
	
    $this->end_controls_section();



    /**
     * Slider Settings
     */

    // Content Section
    $this->start_controls_section(
      'settings_section',
      [
        'label' => 'Slider Settings',
        'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
      ]
    );


    // Auto Play
    $this->add_control(
      'auto_play',
      [
        'label' => esc_html__('Auto Play', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => 'true',
        'options' => [
          'true'  => esc_html__('True', 'plugin-name'),
          'false' => esc_html__('False', 'plugin-name'),
        ],
      ]
    );

    // Speed
    $this->add_control(
      'speed',
      [
        'label' => esc_html__('Speed', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::NUMBER,
        'min' => 100,
        'max' => 10000,
        'default' => 900,
      ]
    );

    // AutoPlay Speed
    $this->add_control(
      'autoplay_speed',
      [
        'label' => esc_html__('Autoplay Speed', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::NUMBER,
        'min' => 100,
        'max' => 10000,
        'default' => 900,
      ]
    );


    // Slide To Show
    $this->add_control(
      'slide_to_show',
      [
        'label' => esc_html__('Slide To Show', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::NUMBER,
        'min' => 1,
        'max' => 6,
        'default' => 1,
      ]
    ); 

    // Slide To Scroll
    $this->add_control(
      'slide_to_scroll',
      [
        'label' => esc_html__('Slide To Scroll', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::NUMBER,
        'min' => 1,
        'max' => 6,
        'default' => 1,
      ]
    );


    // Dot
    $this->add_control(
      'dot',
      [
        'label' => esc_html__('Dot', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => 'false',
        'options' => [
          'true'  => esc_html__('True', 'plugin-name'),
          'false' => esc_html__('False', 'plugin-name'),
        ],
      ]
    );

    
    // Arrows
    $this->add_control(
      'arrows',
      [
        'label' => esc_html__('Arrows', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => 'true',
        'options' => [
          'true'  => esc_html__('True', 'plugin-name'),
          'false' => esc_html__('False', 'plugin-name'),
        ],
      ]
    );

    // Infinite
    $this->add_control(
      'infinite',
      [
        'label' => esc_html__('Infinite', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => 'true',
        'options' => [
          'true'  => esc_html__('True', 'plugin-name'),
          'false' => esc_html__('False', 'plugin-name'),
        ],
      ]
    );

	
    $this->end_controls_section();

	
	
	
	
	  // Content Section
    $this->start_controls_section(
      'responsive_section',
      [
        'label' => 'Responsive Settings',
        'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
      ]
    );

		// Slide To Show
    $this->add_control(
      'slide_rea_show',
      [
        'label' => esc_html__('Mobel Show', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::NUMBER,
        'min' => 1,
        'max' => 6,
        'default' => 2,
      ]
    );
	// Slide To Show
    $this->add_control(
      'slide_reas_show',
      [
        'label' => esc_html__('Tablet Show', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::NUMBER,
        'min' => 1,
        'max' => 6,
        'default' => 2,
      ]
    );
	
	// Slide To Show
    $this->add_control(
      'slide_reass_show',
      [
        'label' => esc_html__('Desktop Show', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::NUMBER,
        'min' => 1,
        'max' => 6,
        'default' => 2,
      ]
    );
	
	
    $this->end_controls_section();
	
	
	
	
	
	
	
	
    /**
     * Slider Style
     */
	 
	 
	 
	  // Box Style
	 $this->start_controls_section(
      'box_style',
      [
        'label' => 'Box Color Option',
        'tab' => \Elementor\Controls_Manager::TAB_STYLE
      ]
    );
	// Box Background  
    $this->add_group_control(
      \Elementor\Group_Control_Background::get_type(),
      [
        'name' => 'boxshover_background',
        'label' => esc_html__('Background', 'plugin-name'),
        'types' => ['classic', 'gradient'],
        'selector' => '{{WRAPPER}} .testi_text ',
      ]
    );
	  // Box Padding 
    $this->add_responsive_control(
      'ser_box_padding',
      [
        'label' => 'Padding',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .testi_text ' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'separator' => 'before',
      ]
    );

    // Box Margin
    $this->add_responsive_control(
      'ser_box_margin',
      [
        'label' => 'Margin',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .testi_text ' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'separator' => 'before',
      ]
    );
	 
	/* box shadow */	
	$this->add_group_control(
		\Elementor\Group_Control_Box_Shadow::get_type(),
		[
			'name' => 'witr_box_shadowsbox',
			'label' => esc_html__( 'Box Shadow', 'morat' ),
			'selector' => '{{WRAPPER}} .testi_text ',
		]
	); 
	 
	 /* witr_border_style */
	$this->add_control(
		'box_border',
		[
			'label' => esc_html__( 'Border Style', 'plugin-name' ),
			'type' => \Elementor\Controls_Manager::SELECT,
			'options' => [
				'none' => esc_html__( 'none', 'plugin-name' ),
				'solid' => esc_html__( 'Solid', 'plugin-name' ),
				'double' => esc_html__( 'Double', 'plugin-name' ),
				'dotted' => esc_html__( 'Dotted', 'plugin-name' ),
				'dashed' => esc_html__( 'Dashed', 'plugin-name' ),
				'default' => esc_html__( 'Default', 'plugin-name' ),
			],
			'default' => 'none',
			'selectors' => [
				 '{{WRAPPER}} .testi_text ' => 'border-style: {{VALUE}}',
			],
		]
	);		
	/* witr border */
	
	$this->add_control(
		'box_bods_style',
		[
			'label' => esc_html__( 'Width', 'plugin-name' ),
			'type' => \Elementor\Controls_Manager::DIMENSIONS,
			'selectors' => [
				 '{{WRAPPER}} .testi_text ' => 'border-width: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
			],
			'condition' => [
				'box_border' => ['solid','double','dotted','dashed'],
			],								
		]
	);
	/* border_color */
	$this->add_control(
		'boxs_border1_color',
		[
			'label' => esc_html__( 'Border Color', 'plugin-name' ),
			'type' =>  \Elementor\Controls_Manager::COLOR,
			
			'selectors' => [
				'{{WRAPPER}} .testi_text ' => 'border-color: {{VALUE}}',
			],
			'condition' => [
				'box_border' => ['solid','double','dotted','dashed','default'],
			],								
		]
	);
	/* border_radius */
	$this->add_control(
		'testi_radius',
		[
			'label' => esc_html__( 'Border Radius', 'plugin-name' ),
			'type' => \Elementor\Controls_Manager::DIMENSIONS,
			'size_units' => [ 'px', '%' ],
			'selectors' => [
				'{{WRAPPER}} .testi_text ' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
			],							
		]
	);
	 
	 
	 /* border_color */
	$this->add_control(
		'border1_hover_color',
		[
			'label' => esc_html__( 'Border Hover Color', 'plugin-name' ),
			'type' =>  \Elementor\Controls_Manager::COLOR,
			
			'selectors' => [
				'{{WRAPPER}} .testi_text:hover ' => 'border-color: {{VALUE}}',
			],
		]
	);
	
	$this->end_controls_section();
	 
	 
	 
	 
	 
	 
	 
	 
    // Top Title Style
    $this->start_controls_section(
      'main_top_title_style',
      [
        'label' => 'Top Title',
        'tab' => \Elementor\Controls_Manager::TAB_STYLE
      ]
    );

    // Main Title Typography
    $this->add_group_control(
      \Elementor\Group_Control_Typography::get_type(),
      [
        'name' => 'testi_top_title_typography',
        'selector' => '{{WRAPPER}} .testi_content h1',
      ]
    );

    // Main Title Color
    $this->add_control(
      'main_top_title_color',
      [
        'label' => esc_html__('Main Title Color', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
          '{{WRAPPER}} .testi_content h1' => 'color: {{VALUE}}',
        ],
      ]
    );
	 // Main Title Padding
    $this->add_responsive_control(
      'main_top_title_padding',
      [
        'label' => 'Padding',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .testi_content h1' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'separator' => 'before',
      ]
    );

    // Main Title Margin
    $this->add_responsive_control(
      'main_top_title_margin',
      [
        'label' => 'Margin',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .testi_content h1' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'separator' => 'before',
      ]
    );
	

    $this->end_controls_section();
	 
	 
	 
	 
	 
    // Main Title Style
    $this->start_controls_section(
      'main_title_style',
      [
        'label' => 'Sub Title',
        'tab' => \Elementor\Controls_Manager::TAB_STYLE
      ]
    );

    // Main Title Typography
    $this->add_group_control(
      \Elementor\Group_Control_Typography::get_type(),
      [
        'name' => 'main_title_typography',
        'selector' => '{{WRAPPER}} .testi_content h2, {{WRAPPER}} .testi_title span',
      ]
    );

    // Main Title Color
    $this->add_control(
      'main_title_color',
      [
        'label' => esc_html__('Main Title Color', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
          '{{WRAPPER}} .testi_content h2, {{WRAPPER}} .testi_title span' => 'color: {{VALUE}}',
        ],
      ]
    );
	 // Main Title Padding
    $this->add_responsive_control(
      'main_title_padding',
      [
        'label' => 'Padding',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .testi_content h2, {{WRAPPER}} .testi_title span' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'separator' => 'before',
      ]
    );

    // Main Title Margin
    $this->add_responsive_control(
      'main_title_margin',
      [
        'label' => 'Margin',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .testi_content h2, {{WRAPPER}} .testi_title span' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'separator' => 'before',
      ]
    );
	

    $this->end_controls_section();

	
	
	
	
    // content Title Style
    $this->start_controls_section(
      'sub_title_style',
      [
        'label' => 'Content Title',
        'tab' => \Elementor\Controls_Manager::TAB_STYLE
      ]
    );

    // content Title Typography
    $this->add_group_control(
      \Elementor\Group_Control_Typography::get_type(),
      [
        'name' => 'content_title_typography',
        'selector' => '{{WRAPPER}} .testi_text p, {{WRAPPER}} .testimonial_content p',
      ]
    );

	// content Width
    $this->add_responsive_control(
      'content_width',
      [
        'type' => \Elementor\Controls_Manager::SLIDER,
        'label' => esc_html__('Width', 'plugin-name'),
        'size_units' => ['px', '%'],
        'range' => [
          'px' => [
            'min' => 0,
            'max' => 500,
          ],
          '%' => [
            'min' => 0,
            'max' => 100
          ]
        ],
        'selectors' => [
          '{{WRAPPER}} .testi_text p, {{WRAPPER}} .testimonial_content p' => 'width: {{SIZE}}{{UNIT}};',
        ],
      ]
    );	
	
    // Main Title Color
    $this->add_control(
      'content_title_color',
      [
        'label' => esc_html__('Sub Title Color', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
          '{{WRAPPER}} .testi_text p, {{WRAPPER}} .testimonial_content p' => 'color: {{VALUE}}',
        ],
      ]
    );
	
	 // Main Title Padding
    $this->add_responsive_control(
      'main_content_padding',
      [
        'label' => 'content Padding',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .testi_text p, {{WRAPPER}} .testimonial_content' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'separator' => 'before',
      ]
    );
	
	 // Background
    $this->add_group_control(
      \Elementor\Group_Control_Background::get_type(),
      [
        'name' => 'content_background',
        'label' => esc_html__('background', 'plugin-name'),
        'types' => ['classic', 'gradient'],
        'selector' => ' {{WRAPPER}} .testimonial_content',
      ]
    );
	
    // Main Title Margin
    $this->add_responsive_control(
      'main_content_margin',
      [
        'label' => 'content Margin',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .testi_text p, {{WRAPPER}} .testimonial_content ' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'separator' => 'before',
      ]
    );
    
    $this->end_controls_section();
	
	
	
	
	
	 // Main Title Style
    $this->start_controls_section(
      'subs_title_style',
      [
        'label' => 'Sub Title',
        'tab' => \Elementor\Controls_Manager::TAB_STYLE
      ]
    );

    // Main Title Typography
    $this->add_group_control(
      \Elementor\Group_Control_Typography::get_type(),
      [
        'name' => 'testi title typography',
        'selector' => '{{WRAPPER}} .testi_content h2, {{WRAPPER}} .testi_title span',
      ]
    );

    // Main Title Color
    $this->add_control(
      'testi_title_color',
      [
        'label' => esc_html__('Main Title Color', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
          '{{WRAPPER}} .testi_content h2, {{WRAPPER}} .testi_title span' => 'color: {{VALUE}}',
        ],
      ]
    );
	 // Main Title Padding
    $this->add_responsive_control(
      'test_title_padding',
      [
        'label' => 'Padding',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .testi_content h2, {{WRAPPER}} .testi_title span' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'separator' => 'before',
      ]
    );

    // Main Title Margin
    $this->add_responsive_control(
      'tesss_title_margin',
      [
        'label' => 'Margin',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .testi_content h2, {{WRAPPER}} .testi_title span' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'separator' => 'before',
      ]
    );
	

    $this->end_controls_section();

	
	
	
	
    // Arrow Dot Style
    $this->start_controls_section(
      'arrow_dot_style',
      [
        'label' => 'Arrow Dot Title',
        'tab' => \Elementor\Controls_Manager::TAB_STYLE
      ]
    );
 // Color
    $this->add_control(
      'arre_color',
      [
        'label' => esc_html__('Arrow Color', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
          '{{WRAPPER}} .slick-slider .next_arrow, {{WRAPPER}} .slick-slider .priv_arrow' => 'color: {{VALUE}}',
        ],
      ]
    );
	
    // Background
    $this->add_group_control(
      \Elementor\Group_Control_Background::get_type(),
      [
        'name' => 'background',
        'label' => esc_html__('background', 'plugin-name'),
        'types' => ['classic', 'gradient'],
        'selector' => '{{WRAPPER}} .slick-slider .next_arrow, {{WRAPPER}} .slick-slider .priv_arrow, {{WRAPPER}} .slick-dots li button',
      ]
    );
	
	// Background
    $this->add_group_control(
      \Elementor\Group_Control_Background::get_type(),
      [
        'name' => 'Active background',
        'label' => esc_html__(' Background', 'plugin-name'),
        'types' => ['classic', 'gradient'],
        'selector' => '{{WRAPPER}} .slick-dots li.slick-active button',
      ]
    );
	
	// Arrow Width
		$this->add_responsive_control(
		  'arrow_font_size',
		  [
			'type' => \Elementor\Controls_Manager::SLIDER,
			'label' => esc_html__('font size', 'plugin-name'),
			'size_units' => ['px'],
			'range' => [
			  'px' => [
				'min' => 0,
				'max' => 500,
			  ],
			  '%' => [
				'min' => 0,
				'max' => 100
			  ]
			],
			'selectors' => [
			  '{{WRAPPER}} .slick-slider .next_arrow, {{WRAPPER}} .slick-slider .priv_arrow, {{WRAPPER}} .slick-dots li button' => 'font-size: {{SIZE}}{{UNIT}};',
			],
		  ]
		);
	
	// Arrow Width
    $this->add_responsive_control(
      'arrow_width',
      [
        'type' => \Elementor\Controls_Manager::SLIDER,
        'label' => esc_html__('Width', 'plugin-name'),
        'size_units' => ['px', '%'],
        'range' => [
          'px' => [
            'min' => 0,
            'max' => 500,
          ],
          '%' => [
            'min' => 0,
            'max' => 100
          ]
        ],
        'selectors' => [
          '{{WRAPPER}} .slick-slider .next_arrow, {{WRAPPER}} .slick-slider .priv_arrow, {{WRAPPER}} .slick-dots li button' => 'width: {{SIZE}}{{UNIT}};',
        ],
      ]
    );
	// Arrow height
    $this->add_responsive_control(
      'arrow_height',
      [
        'type' => \Elementor\Controls_Manager::SLIDER,
        'label' => esc_html__('height', 'plugin-name'),
        'size_units' => ['px', '%'],
        'range' => [
          'px' => [
            'min' => 0,
            'max' => 500,
          ],
          '%' => [
            'min' => 0,
            'max' => 100
          ]
        ],
        'selectors' => [
          '{{WRAPPER}} .slick-slider .next_arrow, {{WRAPPER}} .slick-slider .priv_arrow, {{WRAPPER}} .slick-dots li button' => 'height: {{SIZE}}{{UNIT}};',
        ],
      ]
    );	
	// Arrow height
    $this->add_responsive_control(
      'arrow_line-height',
      [
        'type' => \Elementor\Controls_Manager::SLIDER,
        'label' => esc_html__('line-height', 'plugin-name'),
        'size_units' => ['px', '%'],
        'range' => [
          'px' => [
            'min' => 0,
            'max' => 500,
          ],
          '%' => [
            'min' => 0,
            'max' => 100
          ]
        ],
        'selectors' => [
          '{{WRAPPER}} .slick-slider .next_arrow, {{WRAPPER}} .slick-slider .priv_arrow, {{WRAPPER}} .slick-dots li button' => 'line-height: {{SIZE}}{{UNIT}};',
        ],
      ]
    );
	
	/* arrow Opacity */
		$this->add_responsive_control(
			'arrow_opacity',
			[
				'label' => esc_html__( 'Arrow Opacity', 'plugin-name' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'selectors' => [
					'{{WRAPPER}} .slick-slider .next_arrow, {{WRAPPER}} .slick-slider .priv_arrow, {{WRAPPER}} .slick-dots li button' => 'opacity: {{SIZE}}{{UNIT}};',
				],
			]
		);	
	
	// Arrow Width
    $this->add_responsive_control(
      'active_width',
      [
        'type' => \Elementor\Controls_Manager::SLIDER,
        'label' => esc_html__('Active Width', 'plugin-name'),
        'size_units' => ['px', '%'],
        'range' => [
          'px' => [
            'min' => 0,
            'max' => 500,
          ],
          '%' => [
            'min' => 0,
            'max' => 100
          ]
        ],
        'selectors' => [
          '{{WRAPPER}} .slick-dots li.slick-active button' => 'width: {{SIZE}}{{UNIT}};',
        ],
      ]
    );
	// Arrow Width
    $this->add_responsive_control(
      'active_height',
      [
        'type' => \Elementor\Controls_Manager::SLIDER,
        'label' => esc_html__('Active height', 'plugin-name'),
        'size_units' => ['px', '%'],
        'range' => [
          'px' => [
            'min' => 0,
            'max' => 500,
          ],
          '%' => [
            'min' => 0,
            'max' => 100
          ]
        ],
        'selectors' => [
          '{{WRAPPER}} .slick-dots li.slick-active button' => 'height: {{SIZE}}{{UNIT}};',
        ],
      ]
    );
	
	
	
		/* witr_border_style */
			$this->add_control(
				'arrow_border',
				[
					'label' => esc_html__( 'Border Style', 'plugin-name' ),
					'type' => \Elementor\Controls_Manager::SELECT,
					'options' => [
						'none' => esc_html__( 'none', 'plugin-name' ),
						'solid' => esc_html__( 'Solid', 'plugin-name' ),
						'double' => esc_html__( 'Double', 'plugin-name' ),
						'dotted' => esc_html__( 'Dotted', 'plugin-name' ),
						'dashed' => esc_html__( 'Dashed', 'plugin-name' ),
						'default' => esc_html__( 'Default', 'plugin-name' ),
					],
					'default' => 'none',
					'selectors' => [
						'{{WRAPPER}} .slick-slider .next_arrow, {{WRAPPER}} .slick-slider .priv_arrow, {{WRAPPER}} .slick-dots li button' => 'border-style: {{VALUE}}',
					],
				]
			);		
			/* witr border */
			
			$this->add_control(
				'arrow_btn_style',
				[
					'label' => esc_html__( 'Width', 'plugin-name' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'selectors' => [
						'{{WRAPPER}} .slick-slider .next_arrow, {{WRAPPER}} .slick-slider .priv_arrow, {{WRAPPER}} .slick-dots li button' => 'border-width: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],
					'condition' => [
						'arrow_border' => ['solid','double','dotted','dashed'],
					],								
				]
			);
			/* border_color */
			$this->add_control(
				'witr_border1_btn_color',
				[
					'label' => esc_html__( 'Border Color', 'plugin-name' ),
					'type' =>  \Elementor\Controls_Manager::COLOR,
					
					'selectors' => [
						'{{WRAPPER}} .slick-slider .next_arrow, {{WRAPPER}} .slick-slider .priv_arrow, {{WRAPPER}} .slick-dots li button' => 'border-color: {{VALUE}}',
					],
					'condition' => [
						'arrow_border' => ['solid','double','dotted','dashed','default'],
					],								
				]
			);
			/* border_radius */
			$this->add_control(
				'arrow_radius',
				[
					'label' => esc_html__( 'Border Radius', 'plugin-name' ),
					'type' => \Elementor\Controls_Manager::DIMENSIONS,
					'size_units' => [ 'px', '%' ],
					'selectors' => [
						'{{WRAPPER}} .slick-slider .next_arrow, {{WRAPPER}} .slick-slider .priv_arrow, {{WRAPPER}} .slick-dots li button' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					],								
				]
			);

			/* witr_icon_top */
			$this->add_responsive_control(
				'arrow_top',
				[
					'label' => esc_html__( 'Arrow Top', 'morat' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => -100,
							'max' => 500,
						],
						'%' => [
							'min' => -100,
							'max' => 100,
						],		
					],						
					'selectors' => [
						'{{WRAPPER}} .slider_active.slick-slider .priv_arrow , {{WRAPPER}} .slider_active.slick-slider .next_arrow, {{WRAPPER}} .slick-dots li button,{{WRAPPER}} .slick-dots, {{WRAPPER}} .slick-slider .next_arrow, {{WRAPPER}} .slick-slider .priv_arrow' => 'top: {{SIZE}}{{UNIT}};',
					],
				]
			);
			/* witr_icon_Bottom */
			$this->add_responsive_control(
				'arrow_bottom',
				[
					'label' => esc_html__( 'Arrow Bottom', 'morat' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => -100,
							'max' => 500,
						],
						'%' => [
							'min' => -100,
							'max' => 100,
						],		
					],						
					'selectors' => [
						'{{WRAPPER}} .slider_active.slick-slider .priv_arrow , {{WRAPPER}} .slider_active.slick-slider .next_arrow, {{WRAPPER}} .slick-dots li button,{{WRAPPER}} .slick-dots' => 'bottom: {{SIZE}}{{UNIT}};',
					],
				]
			);
			// Left
			$this->add_responsive_control(
				'arrow_Left',
				[
					'label' => esc_html__( 'Arrow Left', 'morat' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => -100,
							'max' => 500,
						],
						'%' => [
							'min' => -100,
							'max' => 100,
						],		
					],						
					'selectors' => [
						'{{WRAPPER}} .slider_active.slick-slider .next_arrow,{{WRAPPER}} .slick-dots,{{WRAPPER}} .slick-slider .next_arrow' => 'left: {{SIZE}}{{UNIT}};',
					],
				]
			);
			// right
			$this->add_responsive_control(
				'arrow_right',
				[
					'label' => esc_html__( 'Arrow right', 'morat' ),
					'type' => \Elementor\Controls_Manager::SLIDER,
					'size_units' => [ 'px', '%' ],
					'range' => [
						'px' => [
							'min' => -100,
							'max' => 500,
						],
						'%' => [
							'min' => -100,
							'max' => 100,
						],		
					],						
					'selectors' => [
						'{{WRAPPER}} .slider_active.slick-slider .priv_arrow, {{WRAPPER}} .slick-dots li button ,{{WRAPPER}} .slick-dots,{{WRAPPER}} .slick-slider .priv_arrow ' => 'right: {{SIZE}}{{UNIT}};',
					],
				]
			);
		

	
    
    $this->end_controls_section();
	
	
	
	
	
	
	
	
	

	
    $this->end_controls_section();
		

  
  
  }
  
  
  
  
  

  protected function render() {
    
    $settings = $this->get_settings_for_display();
	
?>
 <?php
	   if (!empty($settings['button_link']['url'])) {
      $this->add_link_attributes('button_link', $settings['button_link']);
    }
?>


    <div class="row">
      <div class="col-lg-12">
        <div class="testimonial_active" id="slick-<?= $this->get_id() ?>" data-slick='{
  "dots": <?= $settings['dot'] ?>,
  "infinite": <?= $settings['infinite'] ?>,
  "autoplay": <?= $settings['auto_play'] ?>,
  "speed": <?= $settings['speed'] ?>,
  "autoplaySpeed": <?= $settings['autoplay_speed'] ?>,
  "slidesToShow": <?= $settings['slide_to_show'] ?>,
  "slidesToScroll": <?= $settings['slide_to_scroll'] ?>,
  "arrows": <?= $settings['arrows'] ?>,
  "prevArrow": "<span class=\"priv_arrow\"><i class=\"icofont-arrow-right\"></i></span>",
  "nextArrow": "<span class=\"next_arrow\"><i class=\"icofont-arrow-left\"></i></span>",
  "responsive": [
    {
      "breakpoint": 1200,
      "settings": {
        "slidesToShow": <?= $settings['slide_reass_show'] ?>,
        "slidesToScroll": 2,
        "infinite": true
      }
    },
    {
      "breakpoint": 992,
      "settings": {
        "slidesToShow": <?= $settings['slide_reas_show'] ?>,
        "slidesToScroll": 2
      }
    },
    {
      "breakpoint": 767,
      "settings": {
        "slidesToShow": <?= $settings['slide_rea_show'] ?>,
        "slidesToScroll": 1
      }
    }
  ]
}'>

          <?php foreach ($settings['list'] as $slide) : ?>
		  
		  <?php if ($settings['testimonial_style'] == '1') : ?>
            <!--======== slider ========-->
            <div class="txt_testimonial_area ">
                  <div class="col-lg-12">
                    <div class=" testi_text">
					<img class="left1_image" src="<?= $slide['left_image']['url'] ?>)" alt="">
                      <p><?= $slide['list_content_title'] ?></p>
						<div class="testi_content">
							<h1><?= $slide['top_title'] ?></h1>
							<span><?= $slide['list_main_title'] ?></span>
					   </div>
					  
					 </div>
                  </div>
            </div>
			
			<?php else : ?>
			
			<?php if ($settings['testimonial_style'] == '2') : ?>
			
			<div class="txt_testimonial_area testimonial_style_02">
                  <div class="col-lg-12">
					<div class="testimonial_box_area">
						<div class="testi_icon_area">
							<div class="quote_icon">
								<i class="icofont-quote-right"></i>
							</div>
							<div class="star_icon">
								<i class="icofont-star"></i>
								<i class="icofont-star"></i>
								<i class="icofont-star"></i>
								<i class="icofont-star"></i>
								<i class="icofont-star"></i>
							</div>
						</div>
						<div class="testimonial_content">
							<p><?= $slide['list_content_title'] ?></p>
						</div>
						<div class="testi_content ">
							<div class="testi_thumb">
								<img class="left1_image" src="<?= $slide['left_image']['url'] ?>)" alt="">
							</div>
							<div class="testi_title">
								<h1><?= $slide['top_title'] ?></h1>
								<span><?= $slide['list_main_title'] ?></span>
							</div>
					   </div>
					  
					 </div>
                  </div>
            </div>
		
		<?php endif ?>
		<?php endif ?>
          <?php endforeach ?>

        </div>
      </div>
    </div>
	
	

    <?php if (is_admin()) :
      if (!defined('ELEMENTOR_VERSION'))
        return;
    ?>
      <script>
        // $(".slider_active").slick();

        $("#slick-<?= $this->get_id() ?>").slick();

      </script>

    <?php endif ?>

<?php
  }
}
