<?php
if (!defined('ABSPATH')) {
  exit; // Exit if accessed directly.
}

/**
 * Team Widget
 */

class Team_Widget2 extends \Elementor\Widget_Base {
  public function get_name() {
    return 'morat-team2';
  }

  public function get_title() {
    return esc_html__('lobex 02 Team', 'lobex-widget');
  }

  public function get_categories() {
    return ['basic'];
  }

  /**
   * Controls
   */

  protected function register_controls() {
	  
    // Content Section
	$this->start_controls_section(
      'content_section',
      [
        'label' => esc_html__('Team 02 Content', 'plugin-name'),
        'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
      ]
    );

    // Team Style
    $this->add_control(
      'team_style',
      [
        'label' => esc_html__('Team Style', 'textdomain'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => '1',
        'options' => [
          '1'  => esc_html__('One', 'textdomain'),
          '2' => esc_html__('Two', 'textdomain'),
        ],
      ]
    );
	
	// Image
    $this->add_control(
      'team_image',
      [
        'label' => esc_html__('Choose Image', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::MEDIA,
        'default' => [
          'url' => plugin_dir_url(__DIR__) . 'assets/images/service-1.jpg',
        ],
      ]
    );
	
	 // Title
    $this->add_control(
      'list_title',
      [
        'label' => esc_html__('Title', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::TEXTAREA,
        'default' => esc_html__('Team Title', 'plugin-name'),
        'label_block' => true,
      ]
    );
	  // Url
    $this->add_control(
      'the_team_title',
      [
        'label' => esc_html__(' Link', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::URL,
        'placeholder' => esc_html__('https://your-link.com', 'plugin-name'),
        'options' => ['url', 'is_external', 'nofollow'],
        'default' => [
          'url' => '#',
          'is_external' => true,
          'nofollow' => true,
          // 'custom_attributes' => '',
        ],
        'label_block' => true,
      ]
    );
	
	
	//Sub Title
    $this->add_control(
      'sub_title',
      [
        'label' => esc_html__('Sub Title', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::TEXTAREA,
        'default' => esc_html__('Team Title', 'plugin-name'),
        'label_block' => true,
      ]
    );
	


    // Icon
    $this->add_control(
      'team_icon1',
      [
        'label' => esc_html__('Icon', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::ICONS,
        'default' => [
          'value' => 'fas fa-circle',
          'library' => 'fa-solid',
        ],
        'recommended' => [
          'fa-solid' => [
            'circle',
            'dot-circle',
            'square-full',
          ],
          'fa-regular' => [
            'circle',
            'dot-circle',
            'square-full',
          ],
        ],
      ]
    );

	
	

    $this->end_controls_section();
	
	
	
	


	
	// Box Style
	 $this->start_controls_section(
      'box_style',
      [
        'label' => 'Box Color Option',
        'tab' => \Elementor\Controls_Manager::TAB_STYLE
      ]
    );
	// Box Background  
    $this->add_group_control(
      \Elementor\Group_Control_Background::get_type(),
      [
        'name' => 'boxs_background',
        'label' => esc_html__('Background', 'plugin-name'),
        'types' => ['classic', 'gradient'],
        'selector' => '{{WRAPPER}} .all_title_team',
      ]
    );
	  // Box Padding 
    $this->add_responsive_control(
      'ser_box_padding',
      [
        'label' => 'Box Padding',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .all_title_team' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        
      ]
    );

    // Box Margin
    $this->add_responsive_control(
      'ser_box_margin',
      [
        'label' => 'Margin',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .all_title_team' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        
      ]
    );
	 
	/* box shadow */	
	$this->add_group_control(
		\Elementor\Group_Control_Box_Shadow::get_type(),
		[
			'name' => 'box_shadow',
			'label' => esc_html__( 'Box Shadow', 'lobex' ),
			'selector' => '{{WRAPPER}} .all_title_team',
		]
	); 
	 
	$this->end_controls_section();
	
	
	// Text Box Style
	 $this->start_controls_section(
      'text_box_style',
      [
        'label' => ' Content Box Option',
        'tab' => \Elementor\Controls_Manager::TAB_STYLE
      ]
    );
	// Box Background  
    $this->add_group_control(
      \Elementor\Group_Control_Background::get_type(),
      [
        'name' => 'text_boxs_background',
        'label' => esc_html__('Background', 'plugin-name'),
        'types' => ['classic', 'gradient'],
        'selector' => '{{WRAPPER}} .wtx_team_content',
      ]
    );
	  // Box Padding 
    $this->add_responsive_control(
      'ter_box_padding',
      [
        'label' => 'text Box Padding',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .wtx_team_content' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
      ]
    );

    // Box Margin
    $this->add_responsive_control(
      'text_box_margin',
      [
        'label' => 'text_Margin',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .wtx_team_content' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        
      ]
    );
	 
	/* box shadow */	
	$this->add_group_control(
		\Elementor\Group_Control_Box_Shadow::get_type(),
		[
			'name' => 'text_box_shadow',
			'label' => esc_html__( 'Box Shadow', 'lobex' ),
			'selector' => '{{WRAPPER}} .wtx_team_content',
		]
	); 
	 
	$this->end_controls_section();
	
	
    /* Title Style */
    $this->start_controls_section(
      'title_style',
      [
        'label' => 'Main Title',
        'tab' => \Elementor\Controls_Manager::TAB_STYLE
      ]
    );

    // Main Title Color
    $this->add_control(
      'title_color',
      [
        'label' => esc_html__('Color', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
          '{{WRAPPER}} .team_main_title a' => 'color: {{VALUE}} !important',
        ],
      ]
    );

    // Main Title Typography
    $this->add_group_control(
      \Elementor\Group_Control_Typography::get_type(),
      [
        'name' => 'title_typography',
        'selector' => '{{WRAPPER}} .team_main_title a',
      ]
    );

    // Main Title Padding
    $this->add_responsive_control(
      'title_padding',
      [
        'label' => 'Padding',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .team_main_title a' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        
      ]
    );

    // Main Title Margin
    $this->add_responsive_control(
      'title_margin',
      [
        'label' => 'Margin',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .team_main_title a' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        
      ]
    );

    $this->end_controls_section();


    /* Sub Title Style */

    $this->start_controls_section(
      'sub_title_style',
      [
        'label' => 'Sub Title',
        'tab' => \Elementor\Controls_Manager::TAB_STYLE
      ]
    );

    // Sub Title Color
    $this->add_control(
      'sub_title_color',
      [
        'label' => esc_html__('Color', 'plugin-name'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
          '{{WRAPPER}} .team_sub_title' => 'color: {{VALUE}} !important',
        ],
      ]
    );

    // Sub Main Title Typography
    $this->add_group_control(
      \Elementor\Group_Control_Typography::get_type(),
      [
        'name' => 'sub_title_typography',
        'selector' => '{{WRAPPER}} .team_sub_title',
      ]
    );

    // Sub Title Padding
    $this->add_responsive_control(
      'sub_title_padding',
      [
        'label' => 'Padding',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .team_sub_title' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        
      ]
    );

    // Sub Title Margin
    $this->add_responsive_control(
      'sub_title_margin',
      [
        'label' => 'Margin',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .team_sub_title' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        
      ]
    );

    $this->end_controls_section();
	
	
   /**
     * Icon Style
     */

	 
	$this->start_controls_section(
      'icon_style',
      [
        'label' => 'Icon Option',
        'tab' => \Elementor\Controls_Manager::TAB_STYLE
      ]
    );
	
    // Icon Color
    $this->add_control(
      'icon_color',
      [
        'label' => 'Color',
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
          '{{WRAPPER}} .team_icon i' => 'color: {{VALUE}}',
        ]
      ]
    );

	// Box Background  
    $this->add_group_control(
      \Elementor\Group_Control_Background::get_type(),
      [
        'name' => 'icon_background',
        'label' => esc_html__('Background', 'plugin-name'),
        'types' => ['classic', 'gradient'],
        'selector' => '{{WRAPPER}} .team_icon i',
      ]
    );
	
    // Icon Size
    $this->add_responsive_control(
      'icon_size',
      [
        'type' => \Elementor\Controls_Manager::SLIDER,
        'label' => esc_html__('Size', 'plugin-name'),
        'range' => [
          'px' => [
            'min' => 0,
            'max' => 200,
          ],
        ],
        'devices' => ['desktop', 'tablet', 'mobile'],
        'selectors' => [
          '{{WRAPPER}} .team_icon i' => 'font-size: {{SIZE}}{{UNIT}};',
        ],
      ]
    );
	// Arrow Width
    $this->add_responsive_control(
      'ser_icons_width',
      [
        'type' => \Elementor\Controls_Manager::SLIDER,
        'label' => esc_html__('Width', 'plugin-name'),
        'size_units' => ['px', '%'],
        'range' => [
          'px' => [
            'min' => 0,
            'max' => 500,
          ],
          '%' => [
            'min' => 0,
            'max' => 100
          ]
        ],
        'selectors' => [
          '{{WRAPPER}} .team_icon i' => 'width: {{SIZE}}{{UNIT}};',
        ],
      ]
    );
	// Arrow height
    $this->add_responsive_control(
      'ser_icons_height',
      [
        'type' => \Elementor\Controls_Manager::SLIDER,
        'label' => esc_html__('height', 'plugin-name'),
        'size_units' => ['px', '%'],
        'range' => [
          'px' => [
            'min' => 0,
            'max' => 500,
          ],
          '%' => [
            'min' => 0,
            'max' => 100
          ]
        ],
        'selectors' => [
          '{{WRAPPER}} .team_icon i' => 'height: {{SIZE}}{{UNIT}};',
        ],
      ]
    );	
	// Line height
    $this->add_responsive_control(
      'ser_icons_line_height',
      [
        'type' => \Elementor\Controls_Manager::SLIDER,
        'label' => esc_html__('line-height', 'plugin-name'),
        'size_units' => ['px', '%'],
        'range' => [
          'px' => [
            'min' => 0,
            'max' => 500,
          ],
          '%' => [
            'min' => 0,
            'max' => 100
          ]
        ],
        'selectors' => [
          '{{WRAPPER}} .team_icon i' => 'line-height: {{SIZE}}{{UNIT}};',
        ],
      ]
    );
	/* witr_border_style */
	$this->add_control(
		'icons_border',
		[
			'label' => esc_html__( 'Border Style', 'plugin-name' ),
			'type' => \Elementor\Controls_Manager::SELECT,
			'options' => [
				'none' => esc_html__( 'none', 'plugin-name' ),
				'solid' => esc_html__( 'Solid', 'plugin-name' ),
				'double' => esc_html__( 'Double', 'plugin-name' ),
				'dotted' => esc_html__( 'Dotted', 'plugin-name' ),
				'dashed' => esc_html__( 'Dashed', 'plugin-name' ),
				'default' => esc_html__( 'Default', 'plugin-name' ),
			],
			'default' => 'none',
			'selectors' => [
				'{{WRAPPER}} .team_icon i' => 'border-style: {{VALUE}}',
			],
		]
	);		
	/* witr border */
	
	$this->add_control(
		'icon_bods_style',
		[
			'label' => esc_html__( 'Width', 'plugin-name' ),
			'type' => \Elementor\Controls_Manager::DIMENSIONS,
			'selectors' => [
				'{{WRAPPER}} .team_icon i' => 'border-width: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
			],
			'condition' => [
				'icons_border' => ['solid','double','dotted','dashed'],
			],								
		]
	);
	/* border_color */
	$this->add_control(
		'service_border1_color',
		[
			'label' => esc_html__( 'Border Color', 'plugin-name' ),
			'type' =>  \Elementor\Controls_Manager::COLOR,
			
			'selectors' => [
				'{{WRAPPER}} .team_icon i' => 'border-color: {{VALUE}}',
			],
			'condition' => [
				'icons_border' => ['solid','double','dotted','dashed','default'],
			],								
		]
	);
	/* border_radius */
	$this->add_control(
		'icons_radius',
		[
			'label' => esc_html__( 'Border Radius', 'plugin-name' ),
			'type' => \Elementor\Controls_Manager::DIMENSIONS,
			'size_units' => [ 'px', '%' ],
			'selectors' => [
				'{{WRAPPER}} .team_icon i' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
			],							
		]
	);
	
	
	
	 // icons Padding
    $this->add_responsive_control(
      'icons_padding',
      [
        'label' => 'Padding',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .team_icon i' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'separator' => 'before',
      ]
    );

    // icons Margin
    $this->add_responsive_control(
      'icons_margin',
      [
        'label' => 'Margin',
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', '%'],
        'selectors' => [
          '{{WRAPPER}} .team_icon i' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'separator' => 'before',
      ]
    );
	
	
	
/* hedding  */
	$this->add_control(
		'witr_hove',
		[
			'label' => esc_html__( ' Hover Color option', 'bitor' ),
			'type' =>\Elementor\Controls_Manager::HEADING,
		]
	);
    
    // icon1 Color
    $this->add_control(
      'icon1_hover_color',
      [
        'label' => 'Color',
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
          '{{WRAPPER}} .all_title_team:hover .team_icon i' => 'color: {{VALUE}}',
        ]
      ]
    );

    // icon1 Background
    $this->add_control(
      'icon1_hover_bg',
      [
        'label' => 'Background',
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
          '{{WRAPPER}} .all_title_team:hover .team_icon i' => 'background-color: {{VALUE}}',
        ]
      ]
    );

   
	 $this->end_controls_section();
		
	
   /**
     * Image Style
     */

    $this->start_controls_section(
      'image_style',
      [
        'label' => 'Image Option',
        'tab' => \Elementor\Controls_Manager::TAB_STYLE
      ]
    );
	//  Width
    $this->add_responsive_control(
      'img_width',
      [
        'type' => \Elementor\Controls_Manager::SLIDER,
        'label' => esc_html__('Width', 'plugin-name'),
        'size_units' => ['px', '%'],
        'range' => [
          'px' => [
            'min' => 0,
            'max' => 500,
          ],
          '%' => [
            'min' => 0,
            'max' => 100
          ]
        ],
        'selectors' => [
          '{{WRAPPER}} .wtx_image_area img' => 'width: {{SIZE}}{{UNIT}};',
        ],
      ]
    );
    // Image Overlay
    $this->add_group_control(
      \Elementor\Group_Control_Background::get_type(),
      [
        'name' => 'image_overlay_background',
        'label' => esc_html__('Overlay Background', 'textdomain'),
        'types' => ['classic', 'gradient', 'video'],
        'selector' => '{{WRAPPER}} .wtx_image_area:before',
      ]
    );
	


    $this->end_controls_section();	
	
	
	
	
	
  }


  protected function render() {
    $settings = $this->get_settings_for_display();
?>

    <?php
    if (!empty($settings['the_team_title']['url'])) {
      $this->add_link_attributes('the_team_title', $settings['the_team_title']);
    }
	
    ?>

	
            <?php if ($settings['team_style'] == '1') : ?>
			
              <!--========  team_t1_01 ======== -->
                <div class=" all_title_team ">
                  <div class="wtx_image_area">
					 <img src="<?= esc_url($settings['team_image']['url']) ?>" alt="">
                  </div>
                  <div class="wtx_team_content">
                    <div class="wtx_content2 content1_bg_color">
						<h5 class="team_main_title"><a <?php echo $this->get_render_attribute_string('the_team_title'); ?>><?= $settings['list_title'] ?></a></h5>
					  <span class="team_sub_title"><?= $settings['sub_title'] ?></span>
                    </div>
                    <div class="team_icon">
						<a href="#"><i class="icofont-facebook"></i> </a>
                           <a href="#"><i class="icofont-twitter"></i></a>
                           <a href="#"><i class="icofont-instagram"></i></a>
                           
                    </div>
                  </div>
                </div>

			<?php elseif ($settings['team_style'] === '2') : ?>
                <div class=" all_title_team team_style2">
                  <div class="wtx_image_area">
                    <img src="<?= esc_url($settings['team_image']['url']) ?>" alt="">
                  </div>
                  <div class="wtx_team_icon">
					
                  </div>
				  
				  
                  <div class="wtx_team_content">
                    <div class="wtx_content2 content1_bg_color">
					  <h5 class="team_main_title"><a <?php echo $this->get_render_attribute_string('the_team_title'); ?>><?= $settings['list_title'] ?></a></h5>
					  <span class="team_sub_title"><?= $settings['sub_title'] ?></span>
                    </div>
                  </div>
                </div>


            <?php endif ?>



<?php
  }
}
