<?php

/**
 * Register Scripts
 */
function add_theme_scripts() {
  // Styles
  wp_enqueue_style('bootstrap', get_template_directory_uri() . '/assets/css/bootstrap.min.css', array(), '1.1', 'all');
  wp_enqueue_style('main-style', get_template_directory_uri() . '/assets/css/main-style.css', array(), '1.1', 'all');
  wp_enqueue_style('slick', get_template_directory_uri() . '/assets/css/slick.min.css', array(), '1.1', 'all');
  wp_enqueue_style('menu', get_template_directory_uri() . '/assets/css/menu.min.css', array(), '1.1', 'all');
  wp_enqueue_style('fonts', get_template_directory_uri() . '/assets/css/fonts.min.css', array(), '1.1', 'all');
  wp_enqueue_style('google-font', 'https://fonts.googleapis.com/css2?family=Fira+Sans:wght@100;200;300;400;500;600;700;800;900&family=Rubik:wght@300;400;500;600;700;800;900&display=swap', array(), '1.1', 'all');

  wp_enqueue_style('responsive', get_template_directory_uri() . '/assets/css/responsive.css', array(), '1.1', 'all');
  wp_enqueue_style('style', get_stylesheet_uri());


  // Javascripts
  wp_enqueue_script('jquery-js', get_template_directory_uri() . '/assets/js/jquery.min.js', array(), 1.1, true);
  wp_enqueue_script('bootstrap-js', get_template_directory_uri() . '/assets/js/bootstrap.min.js', array(), 1.1, true);
    wp_enqueue_style('bootstrap', get_template_directory_uri() . '/assets/css/bootstrap.min.js.map', array(), '1.1', 'all');
  wp_enqueue_script('isotope-js', get_template_directory_uri() . '/assets/js/isotope.pkgd.min.js', array(), 1.1, true);
  wp_enqueue_script('slick-js', get_template_directory_uri() . '/assets/js/slick.min.js', array(), 1.1, true);
  wp_enqueue_script('jquery-menu', get_template_directory_uri() . '/assets/js/jquery.menu.js', array(), 1.1, true);
  wp_enqueue_script('jquery-scrolltofixed', get_template_directory_uri() . '/assets/js/jquery-scrolltofixed-min.js', array(), 1.1, true);
  wp_enqueue_script('jquery-counterup', get_template_directory_uri() . '/assets/js/jquery.counterup.min.js', array(), 1.1, true);
  wp_enqueue_script('contact-mail-js', get_template_directory_uri() . '/assets/js/contact-mail.js', array(), 1.1, true);
  wp_enqueue_script('barfiller-js', get_template_directory_uri() . '/assets/js/barfiller.js', array(), 1.1, true);
  wp_enqueue_script('imageload-js', get_template_directory_uri() . '/assets/js/images-load.js', array(), 1.1, true);
  wp_enqueue_script('theme_all-js', get_template_directory_uri() . '/assets/js/theme_all.js', array(), 1.1, true);
}
add_action('wp_enqueue_scripts', 'add_theme_scripts');


add_action('admin_enqueue_scripts', 'add_media_script');

function add_media_script($hook_suffix) {

  wp_enqueue_media();
  wp_enqueue_script('theme_all-js', get_template_directory_uri() . '/assets/js/media.js', array(), 1.1, true);
}

add_action('admin_enqueue_scripts', 'wptuts_add_color_picker');
function wptuts_add_color_picker($hook) {

  if (is_admin()) {

    // Add the color picker css file       
    wp_enqueue_style('wp-color-picker');

    // Include our custom jQuery file with WordPress Color Picker dependency
    wp_enqueue_script('custom-script-handle', get_template_directory_uri() . '/assets/js/colorpicker.js', array('wp-color-picker'), false, true);
  }
}


// load redux




/**
 * Add Theme Supports
 */

add_theme_support('post-thumbnails');
add_theme_support('custom-logo', array(
  'flex-height' => true,
  'flex-width' => true,
));

add_theme_support('widgets');


/**
 * Register lobex Menus
 */

function register_my_menus() {
  register_nav_menus(
    array(
      'header-menu' => __('Header Menu'),
      'one-menu' => __('One	 Menu'),
      'footer-menu' => __('Footer Menu')
    )
  );
}
add_action('init', 'register_my_menus');


/**
 * Register Sidebars
 */

if(!function_exists('lobex_register_sidebars')){
function lobex_register_sidebars() {

  /* Register the 'Footer One' sidebar. */

  register_sidebar(
    array(
      'id'            => 'footer_one',
      'name'          => __('Footer One'),
      'description'   => __('This sidebar  footer one.'),
      'before_widget' => '<div id="%1$s" class="widget %2$s">',
      'after_widget'  => '</div>',
      'before_title'  => '<div class="txt_foot_title"><h3 class="foot-title">',
      'after_title'   => '</h3></div>',
    )
  );

  /* Footer Two sidebar */
  register_sidebar(
    array(
      'id'            => 'footer_two',
      'name'          => __('Footer Two'),
      'description'   => __('This sidebar footer two.'),
      'before_widget' => '<div id="%1$s" class="widget %2$s">',
      'after_widget'  => '</div>',
      'before_title'  => '<div class="txt_foot_title"><h3 class="foot-title">',
      'after_title'   => '</h3></div>',
    )
  );
  
  /* Footer Two sidebar */
  register_sidebar(
    array(
      'id'            => 'footer_three',
      'name'          => __('Footer three'),
      'description'   => __('This sidebar footer three.'),
      'before_widget' => '<div id="%1$s" class="widget %2$s">',
      'after_widget'  => '</div>',
      'before_title'  => '<div class="txt_foot_title"><h3 class="foot-title">',
      'after_title'   => '</h3></div>',
    )
  );

    /* Footer Foure sidebar */
  register_sidebar(
    array(
      'id'            => 'footer_four',
      'name'          => __('Footer four'),
      'description'   => __('This sidebar footer four.'),
      'before_widget' => '<div id="%1$s" class="widget %2$s">',
      'after_widget'  => '</div>',
      'before_title'  => '<div class="txt_foot_title"><h3 class="foot-title">',
      'after_title'   => '</h3></div>',
    )
  );
  
  
}

}
add_action('widgets_init', 'lobex_register_sidebars');




//disable the brand new WordPress widget editor

add_filter( 'use_widgets_block_editor', '__return_false' );

// Disables the block editor from managing widgets in the Gutenberg plugin.
add_filter( 'gutenberg_use_widgets_block_editor', '__return_false', 100 );

// Disables the block editor from managing widgets. renamed from wp_use_widgets_block_editor
add_filter( 'use_widgets_block_editor', '__return_false' );
/* disable Gutenberg editor */
add_filter('use_block_editor_for_post', '__return_false');




/**
 * Custom Walker for Nav Menu
 */

class lobex_Menu_Walker extends Walker_Nav_Menu {

  private function get_menu_style(){
    $menu_style = '';

    if($menu_font_size = get_option('lobex_menu_font_size')){
      $menu_style .= 'font-size: ' . $menu_font_size . '; ';
    }
    if($menu_color = get_option('lobex_menu_color')){
      $menu_style .= 'color: ' . $menu_color . '; ';
    }
    if($menu_padding = get_option('lobex_menu_padding')){
      $menu_style .= 'padding: ' . $menu_padding . '; ';
    }
    if($menu_margin = get_option('lobex_menu_margin')){
      $menu_style .= 'margin: ' . $menu_margin . '; ';
    }

    return $menu_style;
  }

  function start_lvl(&$output, $depth = 0, $args = \null) {
    $output .= "<ul class='txd_drop_menu1'>";
  }

  function start_el(&$output, $item, $depth = 0, $args = \null, $id = 0) {
    $output .= "<li class='" . implode(" ", $item->classes) . " ";

    if (in_array("menu-item-has-children", $item->classes)) {
      $output .= "menu_icon_child ";
    }

    if (in_array("current-menu-item", $item->classes)) {
      $output .= "ac ";
    }

    $output .= "'><a style='". $this->get_menu_style() ."' href='" . $item->url . "'>";

    $output .= $item->title;
    $output .= "</a>";

    if (in_array("menu-item-has-children", $item->classes)) {
      $output .= "<span class='expand_btn'><i class='fas fa-angle-right'></i></span>";
    }
  }
}


/**
 * lobex Theme Init
 */

function lobex_init() {
  /** 
   * Register Custom Post Type
   */

  $labels = array(
    'name' => 'Team',
    'singular_name' => 'Team',
    'menu_name' => 'Team',
    'all_items' => 'All Members'
  );

  register_post_type(
    'team',
    [
      'labels'             => $labels,
      'public'             => true,
      'publicly_queryable' => true,
      'show_ui'            => true,
      'show_in_menu'       => true,
      'query_var'          => true,
      'rewrite'            => array('slug' => 'team'),
      'capability_type'    => 'post',
      'has_archive'        => true,
      'hierarchical'       => true,
      'menu_position'      => 5,
      'supports'           => array('title', 'editor', 'thumbnail'),
    ]
  );

  /* Register Project Post Type */
  $labels = array(
    'name' => 'Project',
    'singular_name' => 'project',
    'menu_name' => 'Project',
    'all_items' => 'All Projects'
  );

  register_post_type(
    'project',
    [
      'labels'             => $labels,
      'public'             => true,
      'publicly_queryable' => true,
      'show_ui'            => true,
      'show_in_menu'       => true,
      'query_var'          => true,
      'rewrite'            => array('slug' => 'project'),
      'capability_type'    => 'post',
      'has_archive'        => true,
      'hierarchical'       => true,
      'menu_position'      => 5,
      'supports'           => array('title', 'editor', 'thumbnail'),
    ]
  );

  register_taxonomy('project_cat', 'project', array("hierarchical" => true, "label" => "Category", "singular_label" => "category", 'update_count_callback' => '_update_post_term_count', 'query_var' => true, 'rewrite' => array('slug' => 'project_cat', 'with_front' => false), 'public' => true, 'show_ui' => true, 'show_tagcloud' => true, '_builtin' => false, 'show_in_nav_menus' => false));
}

add_action('init', 'lobex_init');


/**
 * Add Custom Fields
 */

function lobex_register_meta_boxes() {
  /* Team Meta Box */
  add_meta_box('team_title', __('Team Title', 'textdomain'), 'lobex_team_title_display_cb', 'team', 'advanced', 'high');
  add_meta_box('team_phone', __('Phone Number', 'textdomain'), 'lobex_team_phone_display_cb', 'team', 'advanced', 'low');
  add_meta_box('team_socials', __('Socials', 'textdomain'), 'lobex_team_socials_display_cb', 'team', 'advanced', 'low');

  /* Page Meta Box */
  add_meta_box('header_style', __('Header Style', 'textdomain'), 'lobex_header_style_render', 'page', 'advanced', 'low');

  add_meta_box('breadcrumb_visibility', __('Breadcrumb Visibility', 'textdomain'), 'lobex_breadcrumb_visibility', 'page', 'advanced', 'low');
}
add_action('add_meta_boxes', 'lobex_register_meta_boxes');

function lobex_team_title_display_cb($post) {
  wp_nonce_field('team_title_nonce', 'team_title_nonce');
  $value = get_post_meta($post->ID, '_team_title', true);

  echo '<input type="text" style="width:100%;" id="team_title" name="team_title" value="' . esc_attr($value) . '" />';
}

function lobex_team_phone_display_cb($post) {
  wp_nonce_field('team_phone_nonce', 'team_phone_nonce');
  $value = get_post_meta($post->ID, '_team_phone', true);

  echo '<input type="text" style="width:100%;" id="team_phone" name="team_phone" value="' . esc_attr($value) . '" />';
}

function lobex_team_socials_display_cb($post) {
  wp_nonce_field('team_socials_nonce', 'team_socials_nonce');
  $value = get_post_meta($post->ID, '_team_socials', true);

  echo '<input type="text" placeholder="facebook link" style="width:60%; margin: 5px 0px" id="team_socials" name="team_socials[]" value="'.$value['facebook'].'" />';
  
  echo '<input type="text" placeholder="twitter link" style="width:60%; margin: 5px 0px" id="team_socials" name="team_socials[]" value="'.$value['twitter'].'" />';
  echo '<input type="text" placeholder="instagram link" style="width:60%; margin: 5px 0px" id="team_socials" name="team_socials[]" value="'.$value['instagram'].'" />';
  echo '<input type="text" placeholder="google link" style="width:60%; margin: 5px 0px" id="team_socials" name="team_socials[]" value="'.$value['google'].'" />';
}

function lobex_header_style_render($post) {
  wp_nonce_field('header_style_nonce', 'header_style_nonce');
  $value = get_post_meta($post->ID, '_header_style', true);
?>

  <select name="header_style" id="header_style">
    <option <?= '1' === $value ? 'selected="selected"' : '' ?> value="1">Header One  page</option>
    <option <?= '2' === $value ? 'selected="selected"' : '' ?> value="2">Header Style Two</option>
    <option <?= '3' === $value ? 'selected="selected"' : '' ?> value="3">Header Style Three</option>
	<option <?= '4' === $value ? 'selected="selected"' : '' ?> value="4">Header Style Foure</option>
  </select>

<?php
}

/** Breadcrumb Visibility */

function lobex_breadcrumb_visibility($post) {
  wp_nonce_field('breadcrumb_visibility_nonce', 'breadcrumb_visibility_nonce');
  $value = get_post_meta($post->ID, '_breadcrumb_visibility', true);
?>

  <select name="breadcrumb_visibility" id="breadcrumb_visibility">
    <option <?= 'true' === $value ? 'selected="selected"' : '' ?> value="true">Show</option>
    <option <?= 'false' === $value ? 'selected="selected"' : '' ?> value="false">Hide</option>
  </select>

<?php
}


/**
 * When the post is saved, saves our custom data.
 *
 * @param int $post_id
 */
function save_meta_box_data($post_id) {


  // Check the user's permissions.
  if (isset($_POST['post_type']) && 'page' == $_POST['post_type']) {

    if (!current_user_can('edit_page', $post_id)) {
      return;
    }
  } else {

    if (!current_user_can('edit_post', $post_id)) {
      return;
    }
  }

  if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
    return;
  }

  // Check if our nonce is set.
  if (isset($_POST['team_title_nonce'])) {

    /* Save team title */
    if (!wp_verify_nonce($_POST['team_title_nonce'], 'team_title_nonce')) {
      return;
    }

    if (!isset($_POST['team_title'])) {
      return;
    }

    $my_data = sanitize_text_field($_POST['team_title']);
    update_post_meta($post_id, '_team_title', $my_data);
  }

  /* Save team phone */
  if (isset($_POST['team_phone_nonce'])) {
    if (!wp_verify_nonce($_POST['team_phone_nonce'], 'team_phone_nonce')) {
      return;
    }

    if (!isset($_POST['team_phone'])) {
      return;
    }
    $my_data = sanitize_text_field($_POST['team_phone']);
    update_post_meta($post_id, '_team_phone', $my_data);
  }

  /* Save team socials */
  if (isset($_POST['team_socials_nonce'])) {
    if (!wp_verify_nonce($_POST['team_socials_nonce'], 'team_socials_nonce')) {
      return;
    }

    if (!isset($_POST['team_socials'])) {
      return;
    }
    $my_data = $_POST['team_socials'];
    $count = count($my_data);
    $new = array();

    $new['facebook'] = $my_data[0];
    $new['twitter'] = $my_data[1];
    $new['instagram'] = $my_data[2];
    $new['google'] = $my_data[3];

    update_post_meta($post_id, '_team_socials', $new);
  }


  /* Save Page Header Style */
  if (isset($_POST['header_style_nonce'])) {
    if (!wp_verify_nonce($_POST['header_style_nonce'], 'header_style_nonce')) {
      return;
    }

    if (!isset($_POST['header_style'])) {
      return;
    }
    $my_data = sanitize_text_field($_POST['header_style']);
    update_post_meta($post_id, '_header_style', $my_data);
  }

  if(isset($_POST['breadcrumb_visibility_nonce'])){
    if(!wp_verify_nonce($_POST['breadcrumb_visibility_nonce'], 'breadcrumb_visibility_nonce')){
      return;
    }

    if(!isset($_POST['breadcrumb_visibility'])){
      return;
    }

    $my_data = sanitize_text_field($_POST['breadcrumb_visibility']);
    update_post_meta($post_id, '_breadcrumb_visibility', $my_data);
  }

}


add_action('save_post', 'save_meta_box_data');


/** Breadcrumbs */

function get_breadcrumb() {
  echo '<a href="' . home_url() . '" rel="nofollow">Home</a>';
  if (is_category() || is_single()) {
    echo "&nbsp;&nbsp;&#187;&nbsp;&nbsp;";
    the_category(' &bull; ');
    if (is_single()) {
      echo " &nbsp;&nbsp;&#187;&nbsp;&nbsp; ";
      the_title();
    }
  } elseif (is_page()) {
    echo "&nbsp;&nbsp;&#187;&nbsp;&nbsp;";
    echo the_title();
  } elseif (is_search()) {
    echo "&nbsp;&nbsp;&#187;&nbsp;&nbsp;Search Results for... ";
    echo '"<em>';
    echo the_search_query();
    echo '</em>"';
  }
}



/**
 * Require lobex Options
 */

require_once get_template_directory() . '/includes/mf-activation.php';
require_once get_template_directory() . '/includes/theme-config.php';






/**
 * Post Views Count
 */

function setPostViews($postID) {
  $countKey = 'post_views_count';
  $count = get_post_meta($postID, $countKey, true);
  if ($count == '') {
    $count = 0;
    delete_post_meta($postID, $countKey);
    add_post_meta($postID, $countKey, '0');
  } else {
    $count++;
    update_post_meta($postID, $countKey, $count);
  }
}

// Post excerpt length
function lobex_custom_excerpt_length($length) {
  return 10;
}
add_filter('excerpt_length', 'lobex_custom_excerpt_length', 999);



remove_action( 'shutdown', 'wp_ob_end_flush_all', 1 );
add_action( 'shutdown', function() {
   while ( @ob_end_flush() );
} );




