<?php

/**
 * Blog Index Page
 *
 * @package WordPress
 * @subpackage lobex
 */

get_header();
?>


<div class="blog_section">
    <div class="container">
        <div class="row">
            <div class="col-md-7 col-md-7 col-sm-12">
                <div class="row blog_top">

                    <?php

                    if (have_posts()) :
                        while (have_posts()) : the_post();
                    ?>

                            <!--========  blog_part ======== -->
                            <div class="col-lg-12 col-md-6">
                                <div class="txt_blog_all_area">
                                    <div class="txt_blg_image">
                                        <a href="#"> <img src="<?= get_the_post_thumbnail_url() ?>" alt=""> </a>
                                    </div>
                                    <div class="txt_tuote_body">
                                        <div class="date_all">
                                            <span><?= get_the_category()[0]->cat_name ?></span>
                                            <span><a href="#"><i class="far fa-calendar-plus"></i></a><?= the_modified_date() ?></span>
                                        </div>
                                        <h3><a href="<?= get_post_permalink() ?>"><?= the_title() ?></a></h3>
                                        <p><?= the_excerpt() ?></p>
                                        <div class="blog_btn">
                                            <a href="<?= get_post_permalink() ?>">READ MORE +</a>
                                        </div>
                                    </div>
                                </div>
                            </div>

                        <?php
                        endwhile;
                        ?>
                        <div class="pagination">
                            <?php echo paginate_links(); ?>
                        </div>
                    <?php
                    endif;
                    ?>


                </div>
            </div>
            <div class="col-lg-5 col-md-6 col-sm-12">
                <div class="blog_right">
                    <div class="search">
                        <!-- <form action="#">
                            <input type="text" placeholder="Search">
                            <button class="search_btn">
                                
                            </button>
                        </form> -->

                        <form role="search" method="get" id="searchform" class="searchform" action="">
                            <div>
                                <label class="screen-reader-text" for="s">Search for:</label>
                                <input type="text" value="" name="s" id="s" />
                                <button type="submit" class="search_btn" id="searchsubmit" value="Search">
                                    <i class="fa fa-search"></i>
                                </button>
                            </div>
                        </form>
                    </div>



                    <?php

                    $popularposts  = new WP_Query(array(
                        'posts_per_page' => 1,
                        'meta_key' => 'post_views_count',
                        'orderby' => 'meta_value_num',
                        'order' => 'DESC'
                    ));

                    if ($popularposts->have_posts()) {
                        while ($popularposts->have_posts()) {
                            $popularposts->the_post();
                    ?>

                            <div class="blog_right_detals">
                                <div class="txt_blg_image">
                                    <a href="#"> <img src="<?= get_the_post_thumbnail_url() ?>" alt=""> </a>
                                </div>
                                <div class="right_detals_inner">
                                    <h3><a href="<?= the_permalink() ?>"><?= the_title() ?></a></h3>
                                    <p><?= the_excerpt() ?></p>
                                    <div class="txt_tuote_btn1">
                                        <a class="txt_qbtn1" href="#">Read More <i class="fas fa-long-arrow-alt-right"></i></a>
                                    </div>
                                </div>
                            </div>

                    <?php
                        }
                    }
                    ?>
                </div>
            </div>
        </div>
    </div>
</div>


<?php get_footer() ?>