<?php

function lobex_customize_register($wp_customize) {
    // lobex Customize Panel
    $wp_customize->add_panel('lobex_customize', array(
        'title' => __('lobex Customize'),
        'description' => '', // Include html tags such as <p>.
        'priority' => 160, // Mixed with top-level-section hierarchy.
    ));


    /** Header Sectiion
     * ================
     */

    $wp_customize->add_section( 'lobex_header_section', array(
        'title' => __( 'Header' ),
        'description' => __( 'Edit Header Contents' ),
        'panel' => 'lobex_customize', // Not typically needed.
        'priority' => 1,
        'capability' => 'edit_theme_options',
    ) );

    // Setting for Header Top
    $wp_customize->add_setting( 'lobex_header_top', array(
        'type' => 'theme_mod', // or 'option'
        'capability' => 'edit_theme_options',
        'default' => 'Edit header top text',
        'transport' => 'refresh', // or postMessage
    ) );

    // Control for Header Top
    $wp_customize->add_control( 'lobex_header_top', array(
        'type' => 'text',
        'priority' => 1, // Within the section.
        'section' => 'lobex_header_section', // Required, core or custom.
        'label' => __( 'Title' )
      ) );

    // Selective Refresh for Header Top
    $wp_customize->selective_refresh->add_partial( 'lobex_header_top', array(
        'selector' => '.top_center_text p',
        'container_inclusive' => false,
        'render_callback' => function() {
            get_theme_mod('lobex_header_top');
        },
    ) );


    /** Footer Section
     * ================
     */

    $wp_customize->add_section( 'lobex_footer_section', array(
        'title' => __( 'Footer' ),
        'description' => __( 'Edit Footer Contents' ),
        'panel' => 'lobex_customize', // Not typically needed.
        'priority' => 2,
        'capability' => 'edit_theme_options',
    ) );

    // Setting for Footer Copy Text
    $wp_customize->add_setting( 'lobex_footer_copyright', array(
        'type' => 'theme_mod', // or 'option'
        'capability' => 'edit_theme_options',
        'default' => 'Edit header top text',
        'transport' => 'refresh', // or postMessage
    ) );

    // Control for Footer Copy Text
    $wp_customize->add_control( 'lobex_footer_copyright', array(
        'type' => 'text',
        'priority' => 1, // Within the section.
        'section' => 'lobex_footer_section', // Required, core or custom.
        'label' => __( 'Copyright Text' )
      ) );
}

add_action('customize_register', 'lobex_customize_register');
